<?php
        /*
         * @author Sofia Oraa
         */
/*----------CONSTANTES GLOBALES-----------*/ 
//Servidor BD Moodle
const serverBDMoodle='';
//Usuarios BD Moodle
const userBDMoodle='';
//Password BD Moodle
const passBDMoodle='';
//Servidor BD Seguridad
const serverBDSecurity='';
//Usuario BD Seguridad
const userBDSecurity='';
//Password BD Seguridad
const passBDSecurity='';
//Correo del Administrador
const email= "";
//Remitente del correo
const header = "From: <>";
//Nombre del Administrador del sistema
const name="";
//Apellido del Administrador
const lastname="";
//Formato Fecha
const format= "D d M Y H:i:s e";
/*----------FIN CONSTANTES GLOBALES-----------*/   

/*----------MAIN-----------*/ 
//Conexion con BD Moodle
$db = mysql_connect(serverBDMoodle, userBDMoodle, passBDMoodle);

if(!$db)
{
	//No se ha podido conectar
        //Correo de aviso al Administrador
        $server="DBMoodle";
        dataBaseConnectionFail ($server);
	exit;
}

//Consulta obtener las notas de MOODLE
$result=queryMoodle ();

//Numero de calificaciones obtenidas
$num_result = mysql_num_rows($result);

if (!$num_result)
{       
    //Si no hay calificaciones salir   
        mysql_close($db);
	exit;
}

//Conexion con Base de datos de Seguridad
$usdb = mysql_connect(serverBDSecurity, userBDSecurity, passBDSecurity);

if(!$usdb)
{
        //No se ha podido conectar
        //Correo de aviso al Administrador
        $server="DBGrades";
        dataBaseConnectionFail ($server);
	exit;
}

//Comparar uno a uno los registros para comprobar la integridad
for($i=0; $i<$num_result;$i++)
{
        $row=mysql_fetch_array($result);
        
        //Buqueda de la coincidencia en la tabla de seguridad
        $sql="select * from gradessecurity.grade_security where itemId=" 
              .$row['id']
              ." and courseId="
              .$row['courseid']
              ." and userId="
              .$row['userid']
             .";";
        $getrow = mysql_query($sql);
        $numero = mysql_num_rows($getrow);

   //No existe la nota
   if($numero==0)
   {   
        //Selección de datos que se que se van a cifrar
            $data = $row['id'].$row['courseid'].$row['userid'].$row['finalgrade'];
        //Se aplica hmac
            $hmac= hash_hmac('sha256', $data, 'pruebas123');
        //Se almacena  
            insertGradeDataBase ($row, $hmac);
   }      

   //Existe la nota
   else {
        //Obtenemos la fila que ha coincidido
        $match = mysql_fetch_array($getrow);
        
        //Selección de datos que se van a cifrar
        $data = $row['id'].$row['courseid'].$row['userid'].$row['finalgrade'];
        
        //Se le aplica hmac
        $hmac= hash_hmac('sha256', $data, 'pruebas123');
        
       //Compara ambos HMAC
       //Si las notas no coinciden -> Nota cambiada
       if($match['hmac']!=$hmac)
       {
          /*
            Estados posibles Flag:
            1 ignorar, ya se ha avisado al encargado de la inconsistencia
            0 Detección de inconsistencia. Mandar aviso.
            2 Inconsistencia Grave. Manda mail al Adminitrador
            3 Inconsistencia Grave. Ya no se avisa más al Administrador
            */
          
          //2 --> Inconsistencia Grave ya detectada. Manda mail al Adminitrador
          if($match['flagConsistency']==2){
                  sendPanicMail($match);
          }
          
          //0 --> Detección de inconsistencia. Mandar aviso
          if($match['flagConsistency']==0){
             //Comprobamos antes la consistencia de la BD Seguridad
                //Selección de datos que se van a cifrar
                $dataCheck = $match['itemId'].$match['courseId'].$match['userId'].$match['finalGrade'];
                //Se aplica hmac
                $hmacCheck= hash_hmac('sha256', $dataCheck, 'pruebas123');
                         
                //Si se detecta Inconsistencia grave --> Estado 2
                if ($match['hmac']!=$hmacCheck){
                  updateGradeFlag($match, 2);
                  sendPanicMail($match);
                  continue;
                }
             
             //Todo correcto en la BD Seguridad
                //Flag --> Estado 1
                updateGradeFlag ($match, 1);
           
                //Buscar Profesor encargado
                $teacher = searchTeacher1 ($row);

                //Si no ha habido coincidencia --> Intruso
                if ($teacher['courseId']=="Error"){
                    //Parametros del Administrador del Sistema
                    $mailParameters = array("firstName"=>name,
                                            "lastName"=>lastname,
                                            "email"=>email,
                                            "courseName"=>$teacher['courseName']);
                    //Parametros del Intruso
                    $mailIntruder = array("userId"=>$teacher['userId'],
                                          "firstName"=>$teacher['firstName'],
                                          "lastName"=>$teacher['lastName'],
                                          "email"=>$teacher['email'],
                                          "courseName"=>$teacher['courseName']);
                    //Mandamos email al Administrador
                    sendMailAdmin ($row, $mailParameters, $mailIntruder, $match);
                }//Si ha habido coincidencia --> Profesor
                else{
                    //Parámetros del Profesor
                    $mailParameters = array("firstName"=>$teacher['firstName'],
                                            "lastName"=>$teacher['lastName'],
                                            "email"=>$teacher['email'],
                                            "courseName"=>$teacher['courseName']);
                    //Mandamos email al Profesor encargado
                    sendMailTeacher($row, $mailParameters, $match);
                }
                       
            //Guardar la inconsistencia en tabla de Log
            insertIntoLog($match, $row);
           
          }//if flag a 0
        }//if notas no coinciden -> Nota cambiada
    }//else Existe nota
}//for

//Cerrar Conexiones a las BD
mysql_close($db);
mysql_close($usdb);
/*----------FIN MAIN-----------*/

/*----------FUNCIONES-----------*/

/*
 * Error al conectar a BD: Seguridad o Moodle
 * 
 * Se envía cada 15 minutos un correo al administrador
 * solicitando que se arregle la conexion con la BD correspondiente
 * Urgente dado que el sistema no estará operativo mientras tanto
 * 
 * @param $server Servidor al que no se ha podido conectar 
 */
function dataBaseConnectionFail ($server){
        $mailto = email;
        $subjectAdmin='Imposible Conetar con la Base de Datos';
        if ($server=="DBMoodle"){
           $body="Estimado/a Administrador "
                  . name ." ". lastname
                  . ",<br> Ha ocurrido un error en la conexión con la base de datos de Moodle
                      cuando la aplicación 'Grade Security' trataba de obtener las notas para su revisión.
                      Le recordamos que la aplicación no podrá seguir comprobando las notas
                      hasta que no sea subsanado dicho error, por favor arregleló con la mayor brevedad.
                      Este mensaje será enviado cada quince minutos hasta que subsane el error.
                      <br>Muchas Gracias.";
        }
        else{
           $body="Estimado/a Administrador "
                  . name ." ". lastname
                  . ",<br> Ha ocurrido un error en la conexión con la base de datos de seguridad 'Grade Security'
                      cuando la aplicación 'Grade Security' trataba de revisar los valores de las notas.
                      Le recordamos que la aplicación no podrá seguir comprobando las notas
                      hasta que no sea subsanado dicho error, por favor arregleló con la mayor brevedad.
                      Este mensaje será enviado cada quince minutos hasta que subsane el error.
                      <br>Muchas Gracias.";
        }
        mail($mailto, $subjectAdmin, $body, header);
}

/*
 * Consulta para obtener las calificaciones de MOODLE
 * 
 * Hay que cambiarla si se produce un cambio en la estructura
 * de la BD de Moodle
 * 
 * @return $result contiene los resultados de la consulta
 * 
 */
function queryMoodle (){
        $query="select item.id, item.itemname, item.courseid, grade.userid, user.firstname, user.lastname, grade.finalgrade, grade.timemodified, item.itemtype, grade.usermodified
               from moodle.mdl_grade_items item, moodle.mdl_grade_grades grade, moodle.mdl_user user
               where 
                    item.id = grade.itemid and
                    user.id = grade.userid and
            
                    courseid not in (select course 
                                     from moodle.mdl_course_completion_criteria CC 
                             
                                     where (CC.criteriatype = 2
                                        and UNIX_TIMESTAMP (DATE_SUB(sysdate(),INTERVAL 30 DAY)) >= CC.timeend));
                ";
        $result = mysql_query($query);
        return $result;
}

/*
 * Inserta una nota nueva en la BD seguridad
 * 
 * Se inserta tanto la nota en claro como la nota cifrada
 * Copia de seguridad en la BD de la aplicacion
 * 
 * @param $row Informacion obtenida de la consulta a Moodle
 * @param $hmac Información cifrada de la nota
 */
function insertGradeDataBase ($row, $hmac){
       $insertGrade = "insert into gradessecurity.grade_security values
                        (NULL,"
                        .$row['id'].", '"
                        .$row['itemname']."', "
                        .$row['courseid'].", "
                        .$row['userid'].", '"
                        .$row['firstname']."', '"
                        .$row['lastname']."', "
                        .$row['finalgrade'].", "
                        .$row['usermodified'].", "
                        .$row['timemodified'].", '"
                        .$row['itemtype']."', '"
                        .$hmac 
                      ."',0);";
	mysql_query($insertGrade);
}

/*
 * Inconsistencia Grave BD Seguridad
 * 
 * Alguien o algo ha comprometido la seguridad de la base de datos segura
 * El hmac no coincide con la informacion en claro
 * Se aviso al Administrador del sistema de la situacion
 * Al ser una incidencia grave se hace cada 15 minutos
 * 
 * @param $match Calificacion relacionada con la inconsistencia Grave
 * 
 */
function sendPanicMail($match){
    //Asunto del mensaje
    $subject="Inconsistencia Grave";
    
    //Cuerpo del mensaje
    $begin='Estimado/a Administrador '
            . name . ' ' . lastname
            .', <br>Se ha detectado un FALLO DE SEGURIDAD GRAVE en la base de datos "GradeSecurity".
            La comprobación interna de seguridad ha detectado una inconsistencia en una de las calificaciones almacenadas
            en dicha base.<br>'
            ."El identificador de la nota que produjo el problema es: "
            .$match['idGradeSecurity']
            .".<br><br>Si desea dejar de recibir correos mientras soluciona la incidencia haga click en el botón que aparece a continuación. De otra forma
              recibirá un correo de aviso cada 15 minutos hasta que solucione la incidencia:";
    $urlPanic1='<form action="urlAdmin.php" method="post">
                        <input type="hidden" name="idGrade" value="'
                        .$match['idGradeSecurity'].'">'
                        .'<input type="hidden" name="status" value="stop">'
               .'<a><input type="submit" value="Detener Correos" /></a></form>'; 
    
    $b1="<br>Una vez que haya solucionado la inconsistencia haga click en el botón que aparece a continuación. 
        El sistema volverá a comprobar el valor de dicha calificación:";
    $urlPanic2='<form action="urlAdmin.php" method="post">
                        <input type="hidden" name="idGrade" value="'
                        .$match['idGradeSecurity'].'">'
                        .'<input type="hidden" name="status" value="end">'
               .'<a><input type="submit" value="Inconsistencia Resuelta" /></a></form>';        
    $body=$begin. $urlPanic1.$b1.$urlPanic2;
    
    
    mail(email, $subject, $body);
}

/*
 * Actualiza el valor del campo FlagConsistency
 * 
 * Cambia el valor del Flag en la BD seguridad
 * 0 --> 1 inconsistencia detectada dejar de avisar cada 15 minutos
 * 0 --> 2 inconsistencia grave, hmac != texto en claro cifrado
 * 
 * @param $match Calificacion a la que se le cambia el valor del flag
 * @param $value Nuevo valor del flag, 1 o 2
 */
function updateGradeFlag ($match, $value){
        $updateflag="update gradessecurity.grade_security set flagConsistency ="
                        .$value 
                        ." where idGradeSecurity=" 
                        .$match['idGradeSecurity']
                    .";";
        mysql_query($updateflag);
}

/*
 * Inserta inconsistencias en el Log
 * 
 * Inserta los valores inconsistenets en la tabla de Log
 * Historico de errores
 * 
 * @param $match Nota almacenada en seguridad
 * @param $row Nota obtenida de Moodle
 */
function insertIntoLog($match, $row){
        //Inserta la nota almacenada en local en el log
        $insertLog = "insert into gradessecurity.log_grade_security values
                        (NULL, "
                        .$match['idGradeSecurity'].", "
                        .$match['itemId'].", "
                        .$match['courseId'].", "
                        .$match['userId'].", "
                        .$match['finalGrade'].", "
                        .$match['userModified'].", "
                        .$match['gradeTimeModified'].", "
                        ."UNIX_TIMESTAMP (sysdate()), 'Inconsistencia');";
         mysql_query($insertLog);
            
         //Inserta la nota obtenida de MOODLE en el log
         $insertLog = "insert into gradessecurity.log_grade_security values
                        (NULL, "
                        .$match['idGradeSecurity'].", "
                        .$row['id'].", "
                        .$row['courseid'].", "
                        .$row['userid'].", "
                        .$row['finalgrade'].", "
                        .$row['usermodified'].", "
                        .$row['timemodified'].", "
                        ."UNIX_TIMESTAMP (sysdate()), 'Inconsistencia');";
         mysql_query($insertLog);
}

/*
 * Localiza al Profesor responsable de la inconsistencia
 * 
 * Localiza al usuario que modifico la nota
 * responsable de la ultima modificacion segun los registros de Moodle
 * Lo busca en la base de datos local por primera vez
 * 
 * @see insertaProfes.php Localiza Profesores
 * @see insertaAdmin.php Localiza Administradores
 * 
 * @param $row Nota obtenida en Moodle
 * 
 * @return $mailParameters Datos del Profesor/Gestor encargado
 * @return $getMailParam Datos del Profesor/Gestor o Intruso
 */
function searchTeacher1 ($row){
     //Buscar el correo del profesor asociado al curso
      $sqlTeacher="select firstName, lastName, email, C.courseId, courseName 
                   from gradessecurity.user_oncharge_course UC, gradessecurity.user_name U, gradessecurity.course_Name C 
                   where UC.userId=U.userId and
                         UC.courseId=C.courseId 
                         and U.userId=" 
                            .$row['usermodified']
                         ." and (C.courseId="
                            .$row['courseid']
                   ." or C.courseId=0);";
      $mailPar = mysql_query($sqlTeacher);
      //Se comprueba que ha dado resultados
      $exists = mysql_num_rows($mailPar);
      
      //Si no hay resultados buscamos en Moodle posibles datos nuevos
      if ($exists==0){
            include"insertaProfes.php";
            include"insertaAdmin.php";
            $getMailParam = searchTeacher2($row);
            return $getMailParam;
      }
      //Si los ha dado hay dos opciones posibles
      else{
         $mailParameters = mysql_fetch_array($mailPar);
         //Si es un Gestor
         if ($mailParameters['courseName']=='System'){
             //Buscamos el nombre del curso al que pertenece la nota
             $course = "select courseName from gradessecurity.course_name where courseid="
                  .$row['courseid']
                  .";";
             $getCourse = mysql_query($course);
             $attachCourse = mysql_fetch_array($getCourse);
             $mailParameters['courseName']=$attachCourse['courseName'];
          }
         //Se devuelven los Parámetros sea lo que sea
         return $mailParameters;
       }
}

                  
/*
 * Nueva busqueda en de los profesores encargados
 * 
 * Localiza al usuario que modifico la nota
 * responsable de la ultima modificacion segun los registros de Moodle.
 * Lo busca en la base de datos local por segunda vez
 * Si esta vez no la encuentra
 * La considera un intruso y manda un mail al administrador del sistema
 * indicandole que se ha detectado un intruso
 * 
 * @param $row Nota obtenida en Moodle
 * 
 * @return $mailParameters Datos del Profesor/Gestor encargado o de Intruso
 */
function searchTeacher2 ($row){
     //Buscamos informacion del profesor o el gestor por segunda vez
      $sqlTeacher2="select firstName, lastName, email, C.courseId, courseName
                   from gradessecurity.user_oncharge_course UC, gradessecurity.user_name U, gradessecurity.course_Name C 
                   where UC.userId=U.userId and UC.courseId=C.courseId and U.userid=" 
                        .$row['usermodified']
                        ." and (C.courseid="
                        .$row['courseid']
                   ." or C.courseId=0);";
      $mailPar2 = mysql_query($sqlTeacher2);
      $exists2 = mysql_num_rows($mailPar2);
      
      //Si tras la segunda busqueda tampoco ha sido detectado
      //Buscamos los datos del intruso en Moodle
      if ($exists2==0){
          //Obtenemos el nombre del curso al que afecta la modificacion
          $course = "select courseName 
                    from gradessecurity.course_name 
                    where courseid="
                        .$row['courseid']
                    .";";
          $getCourse = mysql_query($course);
          $attachCourse = mysql_fetch_array($getCourse);
          
          //Obtenemos los datos del intruso
          $intruder = "SELECT U.id userId, firstname firstName, lastname lastName, email
                       FROM moodle.mdl_user U
                       WHERE U.id="
                           .$row['usermodified']
                       .";";
          $getIntruder = mysql_query($intruder);
          $attachIntruder = mysql_fetch_array($getIntruder);
          //Añadimos los parametros para que se detecte que es un intruso al devolver el valor
          $mailParameters=array("userId"=>$attachIntruder['userId'],
                                "firstName"=>$attachIntruder['firstName'],
                                "lastName"=>$attachIntruder['lastName'],
                                "email"=>$attachIntruder['email'],
                                "courseId"=>"Error",
                                "courseName"=>$attachCourse['courseName']);
          return $mailParameters;
      }
      //Si ha habido coincidencia
      else{
          $mailParameters = mysql_fetch_array($mailPar2);
          //Si es un gestor
          if ($mailParameters['courseName']=='System'){
             //Buscamos el nombre del curso al que pertenece la nota
             $course = "select courseName from gradessecurity.course_name where courseid="
                  .$row['courseid']
                  .";";
             $getCourse = mysql_query($course);
             $attachCourse = mysql_fetch_array($getCourse);
             $mailParameters['courseName']=$attachCourse['courseName'];
          }
          return $mailParameters;
      }
}

/*
 * Mandar correo de aviso al Profesor Responsable
 * 
 * Aviso al profesor encargado de las notas de la inconsistencia
 * 
 * @param $row Nota obtenida de Moodle
 * @param $mailParameters Informacion del Profesor al que avisar
 * @param $match Coincidencia en la base de datos de seguridad
 * 
 * @see getBeginMessage
 * @see getFinalMessage
 */
 function sendMailTeacher ($row, $mailParameters, $match){
     //Parametros del correo
        //Hacia quien va dirigido
        $to = $mailParameters['email'];
        //Asunto
        $subject = "Conflicto en las Notas";
        
        //Cuerpo
        $start = "Estimado/a Profesor/a ";
        $begin = getBeginMessage($mailParameters, $row);
                   
        $end = getFinalMessage($row, $match);
                
        $body= $start. $begin .$end;
                      
         //Envio del correo
         mail($to, $subject, $body);
 }

/*
 * Mandar correo al Administrador del sistema
 * 
 * Se activara cuando se detecte que alguien sin permisos 
 * ha modificado las calificaciones
 * Se mandara un correo al Administrador del sistema
 * Incluyendo los datos del intruso
 * 
 * @param $row Nota obtenida de Moodle
 * @param $mailParameters Informacion del Administrador del sistema
 * @param $mailIntruder Informacion sobre el intruso
 * @param $match Coincidencia en la base de datos de seguridad
 * 
 * @see getBeginMessage
 * @see getFinalMessage
 */
 function sendMailAdmin ($row, $mailParameters, $mailIntruder, $match){
     //Parametros del correo
        //Hacia quien va dirigido
        $to = $mailParameters['email'];
        //Asunto
        $subject = "Conflicto en las Notas";
             
        //Cuerpo
        $start = "Estimado/a Administrador ";
        $begin = getBeginMessage($mailParameters, $row);        
        
        //Información sobre el Intruso
        $intruderMail = "<br>La persona que ha accedido al sistema sin poseer los permisos necesarios es: "
                         . $mailIntruder['firstName']
                         ." "
                         . $mailIntruder['lastName']
                         .". Cuyo Identificador de usuario es: "
                         . $mailIntruder['userId']
                         .", y cuyo email asociado es: "
                         . $mailIntruder['email'];
        $end = getFinalMessage($row, $match);
                                 
        $body= $start. $begin .$intruderMail .$end;
                      
        
        //Envio del correo
        mail($to, $subject, $body);
 }
 
 /*
  * Genera el inicio del mensaje de aviso
  * 
  * Saluda al profesor avisandolo de la incidencia
  * Le indica cual es el curso y la actividad, si procede,
  * que han sido modificados
  * 
  * @param $mailParameters Informacion del Profesor encargado
  * @param $row Nota obtenida de Moodle
  * 
  * @return $beginM Inicio del Mensaje
  */
 function getBeginMessage($mailParameters, $row){
     $beg = $mailParameters['firstName']
            ." " 
            . $mailParameters['lastName']
            .", <br>Se ha detectado un posible acceso no autorizado a las notas del curso '"
            . $mailParameters['courseName']."'";
                    
     //Si la nota es de un curso o de una actividad
     if ($row['itemtype']=='course'){
             $activity = ".<br>La nota global del curso '"
                          . $mailParameters['courseName']
                          ."' ha sido modificada.";
     } else{
             $activity = ".<br>La actividad cuya nota ha sido modificada es: '"
                          . $row['itemname']."'.";
     }
     
     $beginM=$beg.$activity;
     return $beginM;
 }
 
 /*
  * Genera el final del mensaje de aviso
  * 
  * Proporciona datos sobre el alumno afectado
  * La fecha y hora de la Nota modificada y la Nota almacenada
  * El valor de la Nota modificada y la Nota almacenada
  * Los urls para que sea capaz de actualizar autimaticamente la base de datos
  * 
  * @see generateOldUrl
  * @see generateNewUrl
  * 
  * @param $row Nota obtenida de Moodle
  * @param $match Coincidencia en la base de datos de seguridad
  * 
  * @return $endM Final del mensaje
  */
 function getFinalMessage($row, $match){
            $generate1 = ".<br>El alumno afectado por dicho cambio es: "
                     . $row['firstname']
                     ." "
                     . $row['lastname']
                     .".<br>La Hora Inicial en la que se creó la nota es: "
                     . date(format, $match['gradeTimeModified'])
                     .". El Valor Inicial de dicha nota es: "
                     . $match['finalGrade']
                     .".<br>La Hora de Modificacion de la nota es: "
                     . date(format, $row['timemodified'])
                     .". El Valor de la nota tras la Modificación es: "
                     . $row['finalgrade']
                     .".<br>"
                     ."<br>Si la nota real fuera: "
                     . $match['finalGrade']
                     .". Haga click en el siguiente botón, por favor: <br>";
             $urlOldGrade=generateOldUrl($match);
             $generate2 = "<br>Si la nota real fuera: "
                     . $row['finalgrade']
                     .". Haga click en el siguiente botón, por favor: <br>";
             $urlNewGrade=generateNewUrl($row, $match);
             $generate3="Muchas gracias.<br><br>"
                        ."Si no selecciona una de las dos opciones se le enviará un mensaje recordatorio cada 24 horas.<br>";
             
             $endM = $generate1.$urlOldGrade.$generate2.$urlNewGrade.$generate3;
             return $endM;
 }
 
 /*
  * Genera la url que indica que la calificacion correcta es la almacenada
  * 
  * @param $match Coincidencia en la base de datos de seguridad
  * 
  * @return $urlOldGrade Devuelve la url
  */
function generateOldUrl($match){
       $urlOldGrade='<form action="urlTeacher.php" method="post">
                        <input type="hidden" name="grade" value="'
                        .$match['finalGrade'] . '">
                        <input type="hidden" name="idGrade" value="'
                        .$match['idGradeSecurity'].'">'
                        .'<input type="hidden" name="status" value="old">'
                    .'<a><input type="submit" value="Esta es la nota" /></a></form>';
       return $urlOldGrade;
}

/*
 * Genera la url que indica que la calificacion correcta es la nueva
 * 
 * @param $row Nota obtenida de Moodle
 * @param $match Coincidencia en la base de datos de seguridad
 * 
 * @return $urlNewGrade Devuelve la url
 */

function generateNewUrl($row, $match){     
       $urlNewGrade='<form action="urlTeacher.php" method="post">
                        <input type="hidden" name="grade" value="'
                        .$row['finalgrade'] . '">
                        <input type="hidden" name="idGrade" value="'
                        .$match['idGradeSecurity'].'">'
                        .'<input type="hidden" name="status" value="new">'
                    .'<a><input type="submit" value="Esta es la nota" /></a></form>';
       return $urlNewGrade;
}

?>
