<?php
        /*
         * @author Sofia Oraa
         */

/*----------CONSTANTES GLOBALES-----------*/ 
//Servidor de la BD Moodle
const serverBDMoodle='';
//Usuarios BD Moodle
const userBDMoodle='';
//Password BD Moodle
const passBDMoodle='';
//Servidor de la BD Seguridad
const serverBDSecurity='';
//Usuario BD Seguridad
const userBDSecurity='';
//Password BD Seguridad
const passBDSecurity='';
//Correo del Administrador
const email= "";
//Remitente del correo
const header = "From: <>";
//Nombre del Administrador del sistema
const name="";
//Apellido del Administrador
const lastname="";
//Formato Fecha
const format= "d M Y D, H:i:s e";
/*----------FIN CONSTANTES GLOBALES-----------*/ 

/*----------MAIN-----------*/ 
//Conexion con Base de datos de Seguridad
$flagUSDB = mysql_connect(serverBDSecurity, userBDSecurity, passBDSecurity);

if(!$flagUSDB)
{
        //No se ha podido conectar
        //Correo de aviso al Administrador
        $rememberServer="DBGrades";
        dataBaseConnectionFail ($rememberServer);
        exit;
}


//Buscamos si existen avisos sin atender --> FlagConsistency==1
   $searchInconsistency = "select * from gradessecurity.grade_security where flagConsistency=1;";
   $executeSearchInconsistency = mysql_query($searchInconsistency);
   $num_Inconsistencies = mysql_num_rows($executeSearchInconsistency);
   
   //Si existen inconsistencias se envian recordatorios
   for($i=0; $i<$num_Inconsistencies;$i++){
   
       $valueSearchInconsistency = mysql_fetch_array($executeSearchInconsistency);
      
       //Buscamos el segundo valor de la nota.
       //Se encuentra almacenado en el Log del sistema
       $getParametersLog="select * 
                         from gradessecurity.log_grade_security 
                         where id_log_grade_security = 
                               (select max(id_log_grade_security) 
                                from gradessecurity.log_grade_security 
                                where idGradeSecurity=" 
                                .$valueSearchInconsistency['idGradeSecurity']
                         .");";
       $executeParametersLog= mysql_query($getParametersLog);
       $valueParametersLog = mysql_fetch_array($executeParametersLog);
       
       //Conexion con BD Moodle. En caso de que exista Intruso
       $flagDB = mysql_connect(serverBDMoodle, userBDMoodle, passBDMoodle);

       if(!$flagDB)
       {
            //No se ha podido conectar
            //Correo de aviso al Administrador
            $rememberServer="DBMoodle";
            dataBaseConnectionFail ($rememberServer, header);
            mysql_close($flagUSDB);
            exit;
       }
       
       //Buscar Profesor encargado
       $rememberTeacher = searchRememberTeacher ($valueParametersLog);
            
            //Si no ha habido coincidencia --> Intruso
            if ($rememberTeacher['courseId']=="Error"){
                //Parametros del Administrador del Sistema
                $rememberMailParameters = array("firstName"=>name,
                                          "lastName"=>lastname,
                                          "email"=>email,
                                          "courseName"=>$rememberTeacher['courseName']);
                //Parametros del Intruso
                $rememberMailIntruder = array("userId"=>$rememberTeacher['userId'],
                                        "firstName"=>$rememberTeacher['firstName'],
                                        "lastName"=>$rememberTeacher['lastName'],
                                        "email"=>$rememberTeacher['email'],
                                        "courseName"=>$rememberTeacher['courseName']);
                //Mandamos email al Administrador
                sendRememberMailAdmin ($valueSearchInconsistency, $rememberMailParameters, $rememberMailIntruder, $valueParametersLog);
            }//Si ha habido coincidencia --> Profesor
            else{
                //Parámetros del Profesor
                $rememberMailParameters = array("firstName"=>$rememberTeacher['firstName'],
                                          "lastName"=>$rememberTeacher['lastName'],
                                          "email"=>$rememberTeacher['email'],
                                          "courseName"=>$rememberTeacher['courseName']);
                //Mandamos email al Profesor encargado
                sendRememberMailTeacher ($valueSearchInconsistency, $rememberMailParameters, $valueParametersLog);
            }

   }

//Cerrar Conexiones a las BD
@mysql_close($flagDB);
mysql_close($flagUSDB);

/*----------FIN MAIN-----------*/

/*----------FUNCIONES-----------*/

/*
 * Error al conectar a BD: Seguridad o Moodle
 * 
 * Se envía cada 15 minutos un correo al administrador
 * solicitando que se arregle la conexion con la BD correspondiente
 * Urgente dado que el sistema no estará operativo mientras tanto
 * 
 * @param $rememberServer Servidor al que no se ha podido conectar 
 */
function dataBaseConnectionFail ($rememberServer){
        $rememberMailto=email;
        $rememberSubjectAdmin='No se puede conectar con la BD de Moodle';
        if ($rememberServer=="DBMoodle"){
           $bodyAdmin="Estimado/a Administrador "
                  . name ." ". lastname
                  . ",<br> Ha ocurrido un error en la conexión con la base de datos de Moodle
                      cuando la aplicación 'Grade Security' trataba de obtener información sobre un intruso.
                      Le recordamos que la aplicación no podrá seguir comprobando las notas
                      hasta que no sea subsanado dicho error, por favor arregleló con la mayor brevedad.
                      Este mensaje será enviado cada quince minutos hasta que subsane el error.
                      <br>Muchas Gracias.";
        }
        else{
           $bodyAdmin="Estimado/a Administrador "
                  . name ." ". lastname
                  . ",<br> Ha ocurrido un error en la conexión con la base de datos de seguridad 'Grade Security'
                      cuando la aplicación 'Grade Security' trataba de encontrar avisos no resueltos.
                      Le recordamos que la aplicación no podrá seguir comprobando las notas
                      hasta que no sea subsanado dicho error, por favor arregleló con la mayor brevedad.
                      Este mensaje será enviado cada quince minutos hasta que subsane el error.
                      <br>Muchas Gracias.";
        }
        mail($rememberMailto, $rememberSubjectAdmin, $bodyAdmin, header);
}

/*
 * Localiza al Profesor o al intruso responsable de la inconsistencia
 * 
 * Localiza al usuario que modifico la nota
 * responsable de la ultima modificacion segun los registros de seguridad
 * Lo busca en la base de datos local
 * 
 * @param $valueSearchInconsistency Nota nueva almacenada 
 * 
 * @return $rememberMailParameters Datos del Profesor/Gestor encargado
 * @return $rememberGetMailParameters Datos del Intruso
 */
function searchRememberTeacher ($valueParametersLog){
     //Buscar el correo del profesor
      $sqlRememberTeacher="select firstName, lastName, email, C.courseId, courseName 
                           from gradessecurity.user_oncharge_course UC, gradessecurity.user_name U, gradessecurity.course_Name C 
                           where UC.userId=U.userId and UC.courseId=C.courseId and U.userid=" 
                                .$valueParametersLog['userModified']
                                ." and (C.courseid="
                                .$valueParametersLog['courseId']
                           ." or C.courseId=0);";
      $rememberMailPar = mysql_query($sqlRememberTeacher);
      $rememberExists = mysql_num_rows($rememberMailPar);
        
      //Si no lo encuentra es directamente un intruso
      if ($rememberExists==0){
          //Obtenemos el nombre del curso al que afecta la modificacion
          $rememberCourse = "select courseName 
                            from gradessecurity.course_name
                            where courseid="
                                .$valueParametersLog['courseId']
                            .";";
          $rememberGetCourse = mysql_query($rememberCourse);
          $rememberAttachCourse = mysql_fetch_array($rememberGetCourse);
          
          //Obtenemos los datos del intruso
          $rememberIntruder = "SELECT U.id userId, firstname firstName, lastname lastName, email
                               FROM moodle.mdl_user U
                               WHERE U.id="
                                    .$valueParametersLog['userModified']
                               .";";
          $rememberGetIntruder = mysql_query($rememberIntruder);
          $rememberAttachIntruder = mysql_fetch_array($rememberGetIntruder);
          //Añadimos los parametros para que se detecte que es un intruso al devolver el valor
          $rememberGetMailParameters=array("userId"=>$rememberAttachIntruder['userId'],
                                           "firstName"=>$rememberAttachIntruder['firstName'],
                                           "lastName"=>$rememberAttachIntruder['lastName'],
                                           "email"=>$rememberAttachIntruder['email'],
                                           "courseId"=>"Error",
                                           "courseName"=>$rememberAttachCourse['courseName']);
          return $rememberGetMailParameters;
      }
      //Si ha habido coincidencia
      else{
            $rememberMailParameters = mysql_fetch_array($rememberMailPar);
            //Si es un gestor
            if ($rememberMailParameters['courseName']=='System'){
                //Buscamos el nombre del curso al que pertenece la nota
                $rememberCourse = "select courseName 
                                   from gradessecurity.course_name 
                                   where courseid="
                                        .$valueParametersLog['courseId']
                                   .";";
                $rememberGetCourse = mysql_query($rememberCourse);
                $rememberAttachCourse = mysql_fetch_array($rememberGetCourse);
                $rememberMailParameters['courseName']=$rememberAttachCourse['courseName'];
            }
        
        return $rememberMailParameters;
      }//else   
}

/*
 * Mandar correo de aviso al Profesor Responsable
 * 
 * Aviso de recuerdo al profesor encargado de las notas de la inconsistencia
 * 
 * @param $valueSearchInconsistency Nota antigua almacenada
 * @param $rememberMailParameters Informacion del Profesor al que avisar
 * @param $valueParametersLog Nota nueva almacenada
 * 
 * @see getBeginRememberMessage
 * @see getFinalRememberMessage
 */
 function sendRememberMailTeacher ($valueSearchInconsistency, $rememberMailParameters, $valueParametersLog){
     //Parametros del correo
        //Hacia quien va dirigido       
        $rememberTo = $rememberMailParameters['email'];
        //Asunto
        $rememberSubject = "Conflicto en las Notas";
        
        //Cuerpo
        $rememberStart = "Estimado/a Profesor/a ";
        $rememberBegin = getBeginRememberMessage($rememberMailParameters, $valueParametersLog, $valueSearchInconsistency);
                                 
        $rememberEnd = getFinalRememberMessage($valueSearchInconsistency, $valueParametersLog);
                
        $rememberBody = $rememberStart. $rememberBegin . $rememberEnd;

        
        //Envio del correo
        mail($rememberTo, $rememberSubject, $rememberBody, header);
 }

/*
 * Mandar correo de recuerdo al Administrador del sistema
 * 
 * Se activara cuando se detecte que alguien sin permisos 
 * ha modificado las calificaciones
 * Se mandara un correo de recuerdo al Administrador del sistema
 * Incluyendo los datos del intruso
 * 
 * @param $valueSearchInconsistency Nota antigua almacenada
 * @param $rememberMailParameters Informacion del Profesor al que avisar
 * @param $rememberMailIntruder Informacion sobre el intruso
 * @param $valueParametersLog Nota nueva almacenada
 * 
 * @see getBeginRememberMessage
 * @see getFinalRememberMessage
 */
 function sendRememberMailAdmin ($valueSearchInconsistency, $rememberMailParameters, $rememberMailIntruder, $valueParametersLog){
     //Parametros del correo
        //Hacia quien va dirigido
        $rememberTo = $rememberMailParameters['email'];
        //Asunto
        $rememberSubject = "Conflicto en las Notas";
                
        //Cuerpo
        $rememberStart = "Estimado/a Administrador ";
        $rememberBegin = getBeginRememberMessage($rememberMailParameters, $valueParametersLog, $valueSearchInconsistency);
        
        //Información sobre el Intruso
        $rememberIntruderMail = "<br>La persona que ha accedido al sistema sin poseer los permisos necesarios es: "
                                . $rememberMailIntruder['firstName']
                                ." "
                                . $rememberMailIntruder['lastName']
                                .". Cuyo Identificador de usuario es: "
                                . $rememberMailIntruder['userId']
                                .", y cuyo email asociado es: "
                                . $rememberMailIntruder['email'];
        $rememberEnd = getFinalRememberMessage($valueSearchInconsistency, $valueParametersLog);
                
        $rememberBody = $rememberStart. $rememberBegin . $rememberIntruderMail . $rememberEnd;
                      
        //Envio del correo
        mail($to, $subject, $body, header);
 }

 /*
  * Genera el inicio del mensaje de recuerdo
  * 
  * Saluda al profesor recordandole la incidencia y la hora a la que se detecto
  * Le indica cual es el curso y la actividad, si procede,
  * que han sido modificados
  * 
  * @param $rememberMailParameters Informacion del Profesor encargado
  * @param $valueParametersLog Nota nueva almacenada
  * @param $valueSearchInconsistency Nota antigua almacenada
  * 
  * @return $rememberBeginM Inicio del Mensaje
  */
 function getBeginRememberMessage($rememberMailParameters, $valueParametersLog, $valueSearchInconsistency){
           $rememberBeg = $rememberMailParameters['firstName']
                          ." " 
                          . $rememberMailParameters['lastName']
                          .", <br>Este es un mensaje recordatorio. Volvemos a indicarle que seguirá enviándose cada 24 horas hasta que seleccione la nota válida.<br>"
                          ."Se detectó un posible acceso no autorizado a las notas del curso '"
                          . $rememberMailParameters['courseName']
                          ."' el día "
                          . date(format, $valueParametersLog['timeCreated']);
           
            //Si la nota es de un curso o de una actividad
            if ($valueSearchInconsistency['itemType']=='course'){
                  $rememberActivity = ".<br>La nota global del curso '"
                               . $rememberMailParameters['courseName']
                               ."' ha sido modificada";
            } else{
                  $rememberActivity = ".<br>La actividad cuya nota ha sido modificada es: '"
                               . $valueSearchInconsistency['itemName']."'.";
            }
           
           $rememberBeginM=$rememberBeg.$rememberActivity;
           return $rememberBeginM;
 }
 
/*
  * Genera el final del mensaje de recuerdo
  * 
  * Proporciona datos sobre el alumno afectado
  * La fecha y hora de la Nota modificada y la Nota almacenada
  * El valor de la Nota modificada y la Nota almacenada
  * Los urls para que sea capaz de actualizar autimaticamente la base de datos
  * 
  * @see generateRememberOldUrl
  * @see generateRememberNewUrl
  * 
  * @param $valueSearchInconsistency Nota antigua almacenada
  * @param $valueParametersLog Nota nueva almancenada
  * 
  * @return $rememberEndM Final del mensaje
  */
 function getFinalRememberMessage($valueSearchInconsistency, $valueParametersLog){
          $rememberGenerate1= ".<br>El alumno afectado por dicho cambio es: "
                               . $valueSearchInconsistency['userFirstName']
                               ." "
                               . $valueSearchInconsistency['userLastName']
                               .".<br>La Hora Inicial en la que se creó la nota es: "
                               . date(format, $valueSearchInconsistency['gradeTimeModified'])
                               ." El Valor Incial de dicha nota es: "
                               . $valueSearchInconsistency['finalGrade']
                               .".<br>La Hora de Modificacion de la nota es: "
                               . date(format, $valueParametersLog['gradeTimeModified'])
                               ." El Valor de la nota tras la Modificacación es: "
                               . $valueParametersLog['finalGrade']
                               .".<br>"
                               ."<br>Si la nota real fuera: "
                               . $valueSearchInconsistency['finalGrade']
                               .". Haga click en el siguiente botón, por favor: <br>";
          $rememberUrlOldGrade= generateRememberOldUrl($valueSearchInconsistency);
          $rememberGenerate2= "<br>Si la nota real fuera: "
                               . $valueParametersLog['finalGrade']
                               .". Haga click en el siguiente botón, por favor: <br>";
          $rememberUrlNewGrade=  generateRememberNewUrl($valueSearchInconsistency, $valueParametersLog);
          $rememberGenerate3= "Muchas gracias.<br><br>"
                               ."Volvemos a recordarle que si no selecciona la opción real de las dos opciones disponibles este 
                                mensaje se reenviará cada 24 horas.<br>";
           
          $rememberEndM = $rememberGenerate1.$rememberUrlOldGrade.$rememberGenerate2.$rememberUrlNewGrade.$rememberGenerate3;
               return $rememberEndM;
 }
 
 /*
  * Genera la url que indica que la calificacion correcta es la antigua
  * 
  * @param $valueSearchInconsistency Nota antigua almancenada
  * 
  * @return $rememberUrlOldGrade Devuelve la url
  */
function generateRememberOldUrl($valueSearchInconsistency){
       $rememberUrlOldGrade='<form action="http://localhost/Pruebas/urlTeacher.php" method="post">
                                <input type="hidden" name="grade" value="'
                                .$valueSearchInconsistency['finalGrade'] . '">
                                <input type="hidden" name="idGrade" value="'
                                .$valueSearchInconsistency['idGradeSecurity'].'">'
                                .'<input type="hidden" name="status" value="old">'
                            .'<a><input type="submit" value="Esta es la nota" /></a></form>';
       return $rememberUrlOldGrade;
}

/*
 * Genera la url que indica que la calificacion correcta es la nueva
 * 
 * @param $valueSearchInconsistency Nota antigua almacenada
 * @param $valueParametersLog Nota nueva almacenada
 * 
 * @return $urlNewGrade Devuelve la url
 */
function generateRememberNewUrl($valueSearchInconsistency, $valueParametersLog){     
       $rememberUrlNewGrade='<form action="http://localhost/Pruebas/urlTeacher.php" method="post">
                                <input type="hidden" name="grade" value="'
                                .$valueParametersLog['finalGrade'] . '">
                                <input type="hidden" name="idGrade" value="'
                                .$valueSearchInconsistency['idGradeSecurity'].'">'
                                .'<input type="hidden" name="status" value="new">'
                            .'<a><input type="submit" value="Esta es la nota" /></a></form>';
       return $rememberUrlNewGrade;
}

?>
