<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title></title>
    </head>
    <body>
        
        <?php
        /*
         * @author Sofia Oraa
         */
/*----------GLOBAL CONSTANTS-----------*/ 
//Servidor de la BD Seguridad
const serverBDSecurity='';
//Usuario BD Seguridad
const userBDSecurity='';
//Password BD Seguridad
//const passBDSecurity='';
const passBDSecurity='';
//Correo del Administrador
const email= "";
//Remitente del correo
const header = "From: <>";

/*----------GLOBAL CONSTANTS END-----------*/ 

/*----------POST-----------*/ 
//Nota Real del sistema
$grade = $_POST["grade"];
//Indentificador de la nota real del sistema
$idGrade = $_POST["idGrade"];
//Old o New dependiendo de cual sea la nota real
$status = $_POST["status"];
/*----------END POST-----------*/ 
          
/*----------MAIN-----------*/

//Conexion con Base de datos de Seguridad
$updateUSDB = mysql_connect(serverBDSecurity, userBDSecurity, passBDSecurity);

if(!$updateUSDB)
{
        //No se ha podido conectar
        //Correo de aviso al Administrador
        dataBaseConnectionFail ();
	exit;
}

   //Comprobación de que no se ha actualizado previamente
   $beforeUpdate="select flagConsistency 
                  from gradessecurity.grade_security 
                  where idGradeSecurity=" 
                        .$idGrade
                  .";";
   $checkBeforeUpdate= mysql_query($beforeUpdate);
   $valueBeforeUpdate = mysql_fetch_array($checkBeforeUpdate);
   
   //Si no lo ha sido
   if($valueBeforeUpdate['flagConsistency']==1){
        if ($status=='new'){
            //Buscamos los datos de la nueva nota para actualizar
            $searchData="select * 
                        from gradessecurity.log_grade_security 
                        where id_log_grade_security = 
                            (select max(id_log_grade_security) 
                            from gradessecurity.log_grade_security 
                            where idGradeSecurity=" 
                                 .$idGrade
                        .");";
            $excuteSearchData= mysql_query($searchData);
            $valueSearchData= mysql_fetch_array($excuteSearchData);
       
            //Recalculamos el HMAC
            $urlData=$valueSearchData['itemId'].$valueSearchData['courseId'].$valueSearchData['userId'].$grade;
            $urlHmac= hash_hmac('sha256', $urlData, 'pruebas123');
            //Actualizamos la nota en la tabla seguridad
            $updateTable="UPDATE gradessecurity.grade_security 
                         set flagConsistency = 0, finalGrade="
                         .$grade .", gradeTimeModified="
                         .$valueSearchData['gradeTimeModified'].", hmac='"
                         .$urlHmac
                         ."' where idGradeSecurity=" 
                                .$idGrade
                         .";";
            mysql_query($updateTable);
            
            //FlagConsistency==0 --> Incidencia resuelta, volver a comprobar notas
                $updateValue=0;
                updateGradeFlagAdmin ($idGrade, $updateValue);
                
            //Insertar la resolución en el Log
                insertUrlIntoLog($valueSearchData, $idGrade, $grade);
        } else{
            //Buscamos los datos de la nueva nota para introducirlos en el registro
            $searchData="select * 
                        from gradessecurity.log_grade_security 
                        where id_log_grade_security = 
                            (select max(id_log_grade_security) 
                            from gradessecurity.log_grade_security 
                            where idGradeSecurity=" 
                                 .$idGrade
                        .");";
            $excuteSearchData= mysql_query($searchData);
            $valueSearchData= mysql_fetch_array($excuteSearchData);
            
            //FlagConsistency==0 --> Incidencia resuelta, volver a comprobar notas
                $updateValue=0;
                updateGradeFlagAdmin ($idGrade, $updateValue);
            
            //Insertar la resolución en el Log
                insertUrlIntoLog($valueSearchData, $idGrade, $grade);
        }
        echo "Muchas gracias por su ayuda, la incidencia en las notas ha sido resuelta.
             <br>Le recordamos que debe resolver la incidencia en MOODLE si fuera necesario.";
   }else{
        //Si ya ha sido actualizada
        //No debe permitir que se actualice más
        echo "La incidencia en la calificación ya había sido resuelta correctamente. <br>
             No es necesario que siga haciendo clic sobre el enlace correspondiente.
             <br>Si se confundió al elegir en valor de la nota, corríjalo en MOODLE y espere a recibir un nuevo mensaje.";
   }


//Cerramos conexion
mysql_close($updateUSDB);

/*----------FIN MAIN-----------*/


/*----------FUNCIONES-----------*/

/*
 * Error al conectar a BD: Seguridad 
 * 
 * Se envía cada 15 minutos un correo al administrador
 * solicitando que se arregle la conexion con la BD de seguridad
 * Urgente dado que el sistema no estará operativo mientras tanto
 * 
 */
function dataBaseConnectionFail (){
        $urlMailto=email;
        $urlSubjectAdmin='No se puede conectar con la BD de Seguridad';
        $urlBody="Estimado/a Administrador "
                  . name ." ". lastname
                  . ",<br> Ha ocurrido un error en la conexión con la base de datos de seguridad 'Grade Security'
                      cuando la aplicación 'Grade Security' trataba de resolver un conflicto en las notas.
                      Le recordamos que la aplicación no podrá seguir comprobando las notas
                      hasta que no sea subsanado dicho error, por favor arregleló con la mayor brevedad.
                      Este mensaje será enviado cada quince minutos hasta que subsane el error.
                      <br>Muchas Gracias.";
        mail($urlMailto, $urlSubjectAdmin, $urlBody, header);
}

/*
 * Actualiza el valor del campo FlagConsistency
 * 
 * Cambia el valor del Flag en la BD seguridad
 * 1 --> 0 inconsistencia grave resuelta, volver a comprobar la nota
 * 
 * @param $match Calificacion a la que se le cambia el valor del flag
 * @param $value Nuevo valor del flag, 1
 */
function updateGradeFlagAdmin ($idGrade, $urlValue){
        $updateflagAdmin="update gradessecurity.grade_security set flagConsistency ="
                            .$urlValue 
                        ." where idGradeSecurity=" 
                            .$idGrade
                        .";";
        mysql_query($updateflagAdmin);
}

/*
 * Inserta inconsistencia resuelta en el Log
 * 
 * Inserta la resolución de la inconsistencia
 * Historico de errores
 * 
 * @param $valueSearchData Nota almacenada en el Log de seguridad
 * @param $idGrade Identificador de la calificación modificada
 * @param $grade Valor real de la nota
 * 
 */
function insertUrlIntoLog($valueSearchData, $idGrade, $grade){
        //Inserta la nota almacenada en local en el log
        $insertUrlLog = "insert into gradessecurity.log_grade_security values
                        (NULL, "
                        .$idGrade .", "
                        .$valueSearchData['itemId'].", "
                        .$valueSearchData['courseId'].", "
                        .$valueSearchData['userId'].", "
                        .$grade .", "
                        .$valueSearchData['userModified'].", "
                        .$valueSearchData['gradeTimeModified'].", "
                        ."UNIX_TIMESTAMP (sysdate()), 'Resolucion de Inconsistencia');";
         mysql_query($insertUrlLog);
}

?>

    </body>
</html>
